/*
Native Only Loading System ,for MultiTimeframe and MultiPair EA's 
*/
#define NOLS_ERROR_ASSET_NOT_IN_MARKET_WATCH 0
#define NOLS_ERROR_RUN_OUT_OF_ROUNDS         1
string NOLS_ERRORS[]={"ASSET IS NOT IN MARKET WATCH PLEASE ADD IT","LOADING SYSTEM MAXED OUT ITS ATTEMPTS CANT LOAD"};
//We need to load and save rapidly ,so ,cant use string objects 
#ifndef LRUT32
#define LRUT32 32
struct user_text_32
{
ushort text[32];
int    text_size;

user_text_32(void){reset();}
user_text_32(string user_text){reset();from_string(user_text);}

void reset(){text_size=0;ArrayFill(text,0,32,0);}

void from_string(string user_text){
text_size=0;
if(StringLen(user_text)>0){
for(int c=0;c<StringLen(user_text);c++){
if(c>32){break;}
text_size++;
text[text_size-1]=StringGetCharacter(user_text,c);
}}}

bool is_same(user_text_32 &other){
bool same=false;
if(other.text_size==text_size&&text_size!=0){
same=true;
for(int t=0;t<text_size;t++){if(text[t]!=other.text[t]){same=false;break;}}
}
return(same);
}

bool is_same(string user_text){
user_text_32 temp(user_text);
return(is_same(temp));
}

void operator=(string user_text){from_string(user_text);}
bool operator==(string user_text){return(is_same(user_text));}
bool operator!=(string user_text){return(!is_same(user_text));}
bool operator==(user_text_32 &other){return(is_same(other));}
bool operator!=(user_text_32 &other){return(!is_same(other));}
string to_string(){return(ShortArrayToString(text,0,text_size));}
};
#endif 
//System loads a pair on a specific timeframe with an amount of data needed ,so we have an object : 
struct nols_asset
{
bool            is_loaded,try_to_load,in_mw,punch;//maybe we dont need to load some
user_text_32    pair,pair_wps;//_wps = without prefix suffix
ENUM_TIMEFRAMES timeframe;
int             new_chart_times_opened;//times tried to open a new chart -not native- for loading
int             native_chart_times_opened;//times tried to load on the native chart 
int             bars_found_last;//bars found on the last attempt (actually pulled data for)
int             bars_according_to_ibars,bars_according_to_native_bars,bars_to_be_loaded;//the later is pulled when the chart is on the native chart 
bool            POKE_TEST,HAS_LATEST_DATA,HAS_DATA_AMOUNT;
datetime        oldest_data_time,newest_data_time,last_tick_time;
int             times_requested_data;//punch times 

nols_asset(void){reset();}

void reset(){
punch=false;
bars_to_be_loaded=0;
is_loaded=false;try_to_load=false;in_mw=false;
pair.reset();pair_wps.reset();timeframe=NULL;new_chart_times_opened=0;native_chart_times_opened=0;bars_found_last=0;bars_according_to_ibars=0;bars_according_to_native_bars=0;
POKE_TEST=false;
HAS_LATEST_DATA=false;
HAS_DATA_AMOUNT=false;
oldest_data_time=0;newest_data_time=0;last_tick_time=0;
times_requested_data=0;
}
};

/* on to the system that manages the loading struggle , the process i mean .
   mq does this really really really hard but its understandable that its hard
   on the server side too .
   so ,the system will "flash" its state to a file named after the chart id which is unique
   the underlying ea or indicator will not function until the NOLS gives it a green light
   So the system object : 
*/
enum nols_state{
nols_state_init=0,//Init phase , the nols is being prepared here 
nols_state_loading=1,//Loading phase ,this is where all the "flashing" and "violent" loading occurs want the f*n correct data and we will get it 
nols_state_returning_from_load=2,//This is the stage after the last loaded asset ,when we reach this we return to the original symbol and timeframe -maybe the user wants to be there so..
nols_state_go_ahead=3,//At this point the chart is how the user started it ,but we have data, and the ea/indy can operate.
nols_state_no_data=4//This is indicating that either stuff that is required is not in the users market watch , or ,load cant proceed (i.e. no connection)
};
struct nols
{
int             error_type,error_ix;
nols_state      state;//system state 
nols_asset      assets[];//all the assets that must load 
int             total_loaded,current_asset,bars_to_load,max_rounds,current_round,max_attempts_per_asset;//punch limit
user_text_32    original_pair;
ENUM_TIMEFRAMES original_timeframe;
bool            original_autoscroll;
int             original_zoom;
int             PUNCH_STEP,PUNCH_ACCELERATION,PUNCH_NAV_STEP_INTERVAL_MS,PUNCH_TIME_IN_CHART_MS;

nols(void){reset();}

void reset(){
PUNCH_STEP=-10;
PUNCH_ACCELERATION=-1;
PUNCH_NAV_STEP_INTERVAL_MS=50;
PUNCH_TIME_IN_CHART_MS=10000;
state=nols_state_init;
ArrayFree(assets);
total_loaded=0;bars_to_load=0;current_asset=0;
max_rounds=0;current_round=0;max_attempts_per_asset=0;
original_autoscroll=false;
original_zoom=0;
original_pair.reset();
original_timeframe=NULL;
}

string get_error(){
if(error_type==NOLS_ERROR_ASSET_NOT_IN_MARKET_WATCH){
return(NOLS_ERRORS[error_type]+" "+assets[error_ix].pair.to_string());
}
return(NOLS_ERRORS[error_type]);
}

void grab_original(){
original_pair=Symbol();
original_timeframe=(ENUM_TIMEFRAMES)Period();
original_autoscroll=(bool)(ChartGetInteger(0,CHART_AUTOSCROLL));
original_zoom=(int)(ChartGetInteger(0,CHART_SCALE));
}

void reinstate_original(){
if(original_autoscroll){ChartSetInteger(0,CHART_AUTOSCROLL,true);}
ChartSetInteger(0,CHART_SCALE,original_zoom);
ChartSetSymbolPeriod(0,original_pair.to_string(),original_timeframe);
}
void count_loaded(){total_loaded=0;for(int a=0;a<ArraySize(assets);a++){if(assets[a].is_loaded){total_loaded++;}}}

void reset_punches(){for(int a=0;a<ArraySize(assets);a++){assets[a].times_requested_data=0;}}
//find asset in list 
int find_asset(string which_asset){
int found=-1;
for(int a=0;a<ArraySize(assets);a++){
if(assets[a].pair==which_asset){
found=a;break;
}}
return(found);
}

//add asset to list 
int add_asset(string new_asset,ENUM_TIMEFRAMES new_tf,bool should_load,int bars_needed){
int newsize=ArraySize(assets)+1;
assets[newsize-1].pair=new_asset;
assets[newsize-1].pair_wps=new_asset;
assets[newsize-1].timeframe=tf_sanitizer(new_tf);
assets[newsize-1].try_to_load=should_load;
assets[newsize-1].bars_to_be_loaded=bars_needed;
return(newsize-1);
}

//same as above but with prefix suffix
int add_asset_prefix_suffix(string new_asset,string prefix,string suffix,ENUM_TIMEFRAMES new_tf,bool should_load,int bars_needed){
int newsize=ArraySize(assets)+1;
ArrayResize(assets,newsize,0);
assets[newsize-1].pair=prefix+new_asset+suffix;
assets[newsize-1].pair_wps=new_asset;
assets[newsize-1].timeframe=tf_sanitizer(new_tf);
assets[newsize-1].try_to_load=should_load;
assets[newsize-1].bars_to_be_loaded=bars_needed;
return(newsize-1);
}
void setup_non_asset_stuff(int rounds_to_be_had,
                           int attempts_max_per_asset,
                           int punch_negative_step,
                           int punch_negative_acc,
                           int punch_step_interval_ms,
                           int punch_time_in_chart_ms){
max_attempts_per_asset=attempts_max_per_asset;
max_rounds=rounds_to_be_had;
PUNCH_STEP=punch_negative_step;
PUNCH_ACCELERATION=punch_negative_acc;
PUNCH_NAV_STEP_INTERVAL_MS=punch_step_interval_ms;
PUNCH_TIME_IN_CHART_MS=punch_time_in_chart_ms;
}                             
void setup_from_asset_list(string asset_list,
                           string prefix,
                           string suffix,
                           string separator,
                           ENUM_TIMEFRAMES tf_to_load,
                           int bars_to_be_loaded,
                           int rounds_to_be_had,
                           int attempts_max_per_asset,
                           int punch_negative_step,
                           int punch_negative_acc,
                           int punch_step_interval_ms,
                           int punch_time_in_chart_ms){
ushort usep=StringGetCharacter(separator,0);
string results[];
int k=StringSplit(asset_list,usep,results);
//add assets 
for(int a=0;a<k;a++){
add_asset_prefix_suffix(results[a],prefix,suffix,tf_to_load,true,bars_to_be_loaded);
}
//grab original state
grab_original();
//set as init
state=nols_state_init;
//first asset 
current_asset=0;
//bars 
bars_to_load=bars_to_be_loaded;
max_attempts_per_asset=attempts_max_per_asset;
max_rounds=rounds_to_be_had;
PUNCH_STEP=punch_negative_step;
PUNCH_ACCELERATION=punch_negative_acc;
PUNCH_NAV_STEP_INTERVAL_MS=punch_step_interval_ms;
PUNCH_TIME_IN_CHART_MS=punch_time_in_chart_ms;
}

//save
void save(string folder,string filename){
string path=folder+"\\"+filename;
if(FileIsExist(path)){FileDelete(path);}
int fop=FileOpen(path,FILE_WRITE|FILE_BIN);
if(fop!=INVALID_HANDLE){ 
//state
FileWriteInteger(fop,((int)state));
//# of assets
FileWriteInteger(fop,((int)ArraySize(assets)));
//original pair
FileWriteStruct(fop,original_pair);
//original autoscroll
uchar uc=0;if(original_autoscroll){uc=1;}
FileWriteInteger(fop,uc,CHAR_VALUE);
//original zoom
FileWriteInteger(fop,original_zoom);
//original timeframe 
FileWriteInteger(fop,original_timeframe);
//assets loaded
FileWriteInteger(fop,total_loaded);
//current asset
FileWriteInteger(fop,current_asset);
//bars to load
FileWriteInteger(fop,bars_to_load);
//max attempts per asset
FileWriteInteger(fop,max_attempts_per_asset);
//max rounds
FileWriteInteger(fop,max_rounds);
//current round
FileWriteInteger(fop,current_round);
//punch settings 
  FileWriteInteger(fop,PUNCH_STEP);
  FileWriteInteger(fop,PUNCH_ACCELERATION);
  FileWriteInteger(fop,PUNCH_NAV_STEP_INTERVAL_MS);
  FileWriteInteger(fop,PUNCH_TIME_IN_CHART_MS);
//assets
  for(int a=0;a<ArraySize(assets);a++)
  {
  FileWriteStruct(fop,assets[a]);
  }
//assets 
FileClose(fop);
}}
//load 
void load(string folder,string filename){
string path=folder+"\\"+filename;
//if file exists 
reset();
if(FileIsExist(path)){
int fop=FileOpen(path,FILE_READ|FILE_BIN);
if(fop!=INVALID_HANDLE){
//state
state=(nols_state)FileReadInteger(fop);
//# of assets 
int noa=(int)FileReadInteger(fop);
//original pair 
FileReadStruct(fop,original_pair);
//original autoscroll
original_autoscroll=false;
uchar uc=(uchar)FileReadInteger(fop,CHAR_VALUE);
if(uc==1){original_autoscroll=true;}
//original zoom
original_zoom=(int)FileReadInteger(fop);
//original timeframe
original_timeframe=(ENUM_TIMEFRAMES)FileReadInteger(fop);
//assets loaded
total_loaded=(int)FileReadInteger(fop);
//current asset
current_asset=(int)FileReadInteger(fop);
//bars to load
bars_to_load=(int)FileReadInteger(fop);
//max attempts per asset 
max_attempts_per_asset=(int)FileReadInteger(fop);
//max rounds 
max_rounds=(int)FileReadInteger(fop);
//current round
current_round=(int)FileReadInteger(fop);
//punch 
  PUNCH_STEP=(int)FileReadInteger(fop);
  PUNCH_ACCELERATION=(int)FileReadInteger(fop);
  PUNCH_NAV_STEP_INTERVAL_MS=(int)FileReadInteger(fop);
  PUNCH_TIME_IN_CHART_MS=(int)FileReadInteger(fop);
//assets
  if(noa>0)
  {
  ArrayResize(assets,noa,0);
  for(int a=0;a<noa;a++)
  {
  FileReadStruct(fop,assets[a]);
  }}
FileClose(fop);
}}}

};

//various stuff
//timeframe sanitizer , if we get a PERIOD CURRENT in the load loop the system is f*d
ENUM_TIMEFRAMES tf_sanitizer(ENUM_TIMEFRAMES tf){
if(tf==PERIOD_CURRENT){tf=(ENUM_TIMEFRAMES)Period();}
return(tf);
}

//get latest quote time
datetime get_asset_quote_time(string asset){
ResetLastError();
datetime last_quote=(datetime)(SymbolInfoInteger(asset,SYMBOL_TIME));
if(GetLastError()>0){last_quote=0;}
return(last_quote);
}
//get difference from cpu ticker , mind you the ticker goes round so 
uint get_tick_difference(uint now,uint then){
int difference=(int)(((long)now)-((long)then));
if(difference<0){difference=(int)((((long)UINT_MAX)-((long)then))+((long)now));}
return((uint)difference);
}
//zoom out and navigate backwards into a chart so that the server spits out more data
#define CHART_ZOOM_OUT 0
#define CHART_ZOOM_IN  5
void zoom_and_nav(long   which_chart,
                  int    zoom,
                  int    step,
                  int    acceleration,
                  uint   interval,
                  uint   max_time_in_chart_ms){
bool nav=true;
uint start_ticker=GetTickCount(),interval_ticker=GetTickCount();
ChartSetInteger(which_chart,CHART_AUTOSCROLL,false);
ChartSetInteger(which_chart,CHART_SCALE,zoom);
ChartNavigate(which_chart,CHART_END,0);
ChartRedraw(which_chart);ChartRedraw();
while(nav)
{
//move chart if interval
  uint tic=get_tick_difference(GetTickCount(),interval_ticker);
  if(tic>=interval){
  step+=acceleration;
  //nav leftwards 
  ChartNavigate(which_chart,CHART_CURRENT_POS,step);
  ChartRedraw(which_chart);ChartRedraw();
  interval_ticker=GetTickCount();
  }
//stop nav if max time in chart is reached 
  tic=get_tick_difference(GetTickCount(),start_ticker);
  if(tic>=max_time_in_chart_ms){nav=false;}
}}

//check if an asset is in market watch 
bool is_in_market_watch(string asset){
int st=SymbolsTotal(true);
for(int s=0;s<st;s++){
if(SymbolName(s,true)==asset){
return(true);
}}
return(false);
}

//check if a charts data has the latest data 
bool does_chart_have_latest_data(string asset,ENUM_TIMEFRAMES tf){
tf=tf_sanitizer(tf);
datetime last_quote_time=get_asset_quote_time(asset);
if(last_quote_time!=0){
//get latest bar 
  ResetLastError();
  datetime last_bar_time=iTime(asset,tf,0);
  //if no error
    if(GetLastError()==0)
    {
    //and quote time within "Period" of the last bar time 
      int max_distance=PeriodSeconds(tf);
      int this_distance=((int)last_quote_time)-((int)last_bar_time);
      if(this_distance<0){this_distance=(-1)*this_distance;}
      if(this_distance<=max_distance){return(true);}
    }
  //if no error 
}
return(false);
}

bool get_i_rates(string asset,ENUM_TIMEFRAMES tf,int i_as_series,MqlRates &receiver){
int errors=0;
tf=tf_sanitizer(tf);
ResetLastError();
double o=iOpen(asset,tf,i_as_series);errors+=GetLastError();
if(errors==0){double h=iHigh(asset,tf,i_as_series);errors+=GetLastError();
if(errors==0){double l=iLow(asset,tf,i_as_series);errors+=GetLastError();
if(errors==0){double c=iClose(asset,tf,i_as_series);errors+=GetLastError();
if(errors==0){datetime t=iTime(asset,tf,i_as_series);errors+=GetLastError();
if(errors==0){long v=iVolume(asset,tf,i_as_series);errors+=GetLastError();
if(errors==0){long tv=iTickVolume(asset,tf,i_as_series);errors+=GetLastError();
if(errors==0){int sp=iSpread(asset,tf,i_as_series);errors+=GetLastError();
//pass
receiver.open=o;
receiver.high=h;
receiver.low=l;
receiver.close=c;
receiver.time=t;
receiver.spread=sp;
receiver.real_volume=v;
receiver.tick_volume=tv;
return(true);
}}}}}}}
return(false);
}

bool test_request_number_of_rates(string asset,ENUM_TIMEFRAMES tf,int amount){
int pulled=0;
tf=tf_sanitizer(tf);
for(int i=0;i<amount;i++){
MqlRates pull;
if(get_i_rates(asset,tf,i,pull)){pulled++;}
}
if(pulled==amount){return(true);}
return(false);
}

bool poke_test(string asset,ENUM_TIMEFRAMES tf){
tf=tf_sanitizer(tf);
double poke=iClose(asset,tf,0);
for(int bf=0;bf<=20;bf++){
poke=iClose(asset,tf,0);
if(poke!=0){return(true);}//pass
Sleep(50);
}
return(false);
}
//advance nols processes ,we should have checked if a connection exists prior to calling this!
/*
result codes :
0 - Nothing special default
-1 - Error ,must stop
1 - ReExecute without navigating
2 - DontExecute anything else ,await navigation
*/
int advance_nols(nols &n,string folder,string filename){
//INIT STAGE 
  if(n.state==nols_state_init)
  {
  //things to do 
    //check if all assets are in market watch 
    bool all_in_mw=true;
    for(int a=0;a<ArraySize(n.assets);a++){if(!is_in_market_watch(n.assets[a].pair.to_string())){all_in_mw=false;n.error_ix=a;break;}}
    //if all in market watch
    if(all_in_mw){
    //advance to the loading stage .
    /*
    at the loading stage we will be checking the current asset for data 
    and if it fails we will be punching it in the native chart until we hit the attempts limit.
    */
    if(ArraySize(n.assets)>0){n.current_asset=1;n.state=nols_state_loading;n.current_round=1;}
    else{n.state=nols_state_go_ahead;n.save(folder,filename);}
    }else{n.state=nols_state_no_data;n.error_type=NOLS_ERROR_ASSET_NOT_IN_MARKET_WATCH;return(-1);}
  }
//LOADING STAGE 
  //no else ,go straignt in
  if(n.state==nols_state_loading)
  {
  //test the current asset 
  /*
  a.poke 
  b.latest data 
  c.amount of data
   
  if any of a,b,c fails ,we punch it in the native chart and increase the attempts (for the asset)
  if we reach the limit of an asset and we are on the rounds limit (meaning there wont be any more rounds then we stop and declare the error
  if we reach the limit of an asset and we are not on the rounds limit (meaning there will be another loading round) we skip the asset
  
  */
  //1ST LOOP INTO ASSETS 
  for(int a=0;a<ArraySize(n.assets);a++)
  {
  //if not loaded
  if(n.assets[a].is_loaded==false)
  {
  //PER CONVENIENCE 
    string          c_symbol=n.assets[a].pair.to_string();
    ENUM_TIMEFRAMES c_tf=n.assets[a].timeframe;  
  //if this is now the native chart and it has a punch indicator 
    if(c_symbol==Symbol()&&c_tf==Period()&&n.assets[a].punch)
    {
    zoom_and_nav(ChartID(),CHART_ZOOM_OUT,n.PUNCH_STEP,n.PUNCH_ACCELERATION,n.PUNCH_NAV_STEP_INTERVAL_MS,n.PUNCH_TIME_IN_CHART_MS);
    n.assets[a].punch=false;
    }
    //get ibars declaration of data
      n.assets[a].bars_according_to_ibars=iBars(c_symbol,c_tf);
      if(c_symbol==Symbol()&&c_tf==Period()){n.assets[a].bars_according_to_native_bars=Bars(c_symbol,c_tf);}
    //A.POKE 
      if(!n.assets[a].POKE_TEST){n.assets[a].POKE_TEST=poke_test(c_symbol,c_tf);}
    //B.LATEST DATA 
      if(n.assets[a].POKE_TEST&&!n.assets[a].HAS_LATEST_DATA){n.assets[a].HAS_LATEST_DATA=does_chart_have_latest_data(c_symbol,c_tf);}
    //C.DATA AMOUNT 
      if(n.assets[a].POKE_TEST&&n.assets[a].HAS_LATEST_DATA&&!n.assets[a].HAS_DATA_AMOUNT){n.assets[a].HAS_DATA_AMOUNT=test_request_number_of_rates(c_symbol,c_tf,n.assets[a].bars_to_be_loaded);}
    //If they all work ,pass and exit 
      if(n.assets[a].POKE_TEST&&n.assets[a].HAS_LATEST_DATA&&n.assets[a].HAS_DATA_AMOUNT){n.assets[a].is_loaded=true;n.assets[a].punch=false;}
      else{n.assets[a].punch=true;}
  }
  //if not loaded ends here 
  }
  //1ST LOOP INTO ASSETS WILL BE CONCLUDED ENDS HERE 
  //CHECKPOINT : ARE ALL ASSETS LOADED 
    n.count_loaded();
    if(ArraySize(n.assets)==n.total_loaded)
    {
    //if we are on the original state just end the load sequence
      if(n.original_autoscroll==(bool)(ChartGetInteger(0,CHART_AUTOSCROLL))){
      if(n.original_zoom==(int)(ChartGetInteger(0,CHART_SCALE))){
      if(n.original_pair.to_string()==Symbol()){
      if(n.original_timeframe==Period()){
      n.state=nols_state_go_ahead;
      n.save(folder,filename);
      return(0);
      }}}}
      else{
      n.state=nols_state_returning_from_load;n.save(folder,filename);
      }
    }
    else{//If not loaded - still
    //punch limits maxed out ? 
    bool all_punch_limits_maxed=true,non_native_unloaded=false;//set to true if there is an unloaded not on the limit non native
    int native_ix=-1,punch_renav=-1;
    //loop and find the next nav
      for(int a=0;a<ArraySize(n.assets);a++)
      {
      if(n.assets[a].pair.to_string()==Symbol()&&n.assets[a].timeframe==Period()){native_ix=a;}
      //if not loaded
        if(n.assets[a].is_loaded==false)
        {
        //and punch on
        if(n.assets[a].punch)
        {
        //and not on punch limit 
          if(n.assets[a].times_requested_data<n.max_attempts_per_asset)
          {
          all_punch_limits_maxed=false;
          //and not native 
            if(a!=native_ix)
            {
            non_native_unloaded=true;
            punch_renav=a;
            break;
            }
          //and not native ends here 
          }
        //and not on punch limit
        } 
        //and punch on ends here
        }
      //if not loaded 
      }
    //loop and find the next nav 
    
      int left=ArraySize(n.assets)-n.total_loaded;
      //if punch renav exists ... renav
      if(punch_renav!=-1){
      n.assets[punch_renav].times_requested_data++;
      n.save(folder,filename);
      //renav
      ChartSetSymbolPeriod(0,n.assets[punch_renav].pair.to_string(),n.assets[punch_renav].timeframe);
      return(2);
      }
      //if one left on the native chart ,its not loaded and its not on the punch limit 
      else if(!all_punch_limits_maxed&&!non_native_unloaded&&left==1&&native_ix!=-1&&punch_renav==-1){
      //advance it and send a reentry code back 
        n.assets[native_ix].times_requested_data++;
        return(1);//1 reexecute without renav
      }
      //if all punch limits maxed 
      else if(all_punch_limits_maxed){
        n.current_round++;
      //if we have more rounds 
        if(n.current_round<=n.max_rounds){
        //reset punches
          n.reset_punches();
        //reexecution
          return(1);
        }
        else if(n.current_round>n.max_rounds){
        n.error_type=NOLS_ERROR_RUN_OUT_OF_ROUNDS;
        return(-1);
        }//if we dont have more rounds 
      }
    }

  }
//RETURNING FROM LOADING STAGE - TO ORIGINAL
  if(n.state==nols_state_returning_from_load){
  n.state=nols_state_go_ahead;
  n.save(folder,filename);
  n.reinstate_original();
  return(2);
  }
//OPERATIONAL 
  else if(n.state==nols_state_go_ahead){
  n.save(folder,filename);
  }
return(0); 
}
//-1 cant find stop and throw error ,rounds limit //-2 cant find ,rounds limit but ,everything is loaded  
int find_next_unloaded_asset(nols &n,int from_literal){
int ix=from_literal-1;
bool seek=true;
while(seek){
ix++;
//if we go around from the top we must check the rounds !
if(ix==ArraySize(n.assets))
  {
  ix=0;
  n.current_round++;
  //if round limit
  if(n.current_round>n.max_rounds)
  {
  bool all_loaded=true;
  for(int a=0;a<ArraySize(n.assets);a++){if(n.assets[a].is_loaded==false){all_loaded=false;break;}}
  if(all_loaded){seek=false;return(-2);}
  else if(!all_loaded){seek=false;return(-1);}
  }
  //if round limit
  }
//if we go around from the top we must check the rounds !
if(n.assets[ix].is_loaded==false){seek=false;return(ix);}
}
return(-1);
}

void nols_deinit(string folder,string filename,int reason){
//if chart close or terminal close ,delete nols
  if(reason==REASON_PROGRAM||reason==REASON_CHARTCLOSE||reason==REASON_CLOSE){
  string path=folder+"\\"+filename;
  FileDelete(path);
}}

/* usage example

include ofc


*/