//Period to Timeframe 
ENUM_TIMEFRAMES PeriodToTF(int period)
{
if(period==1) return(PERIOD_M1);
if(period==5) return(PERIOD_M5);
if(period==15) return(PERIOD_M15);
if(period==30) return(PERIOD_M30);
if(period==60) return(PERIOD_H1);
if(period==240) return(PERIOD_H4);
if(period==1440) return(PERIOD_D1);
if(period==10080) return(PERIOD_W1);
if(period==43200) return(PERIOD_MN1);
return(PERIOD_CURRENT);
}
int TFToPeriod(ENUM_TIMEFRAMES tf)
{
if(tf==PERIOD_CURRENT) return(Period());
if(tf==PERIOD_M1) return(1);
if(tf==PERIOD_M5) return(5);
if(tf==PERIOD_M15) return(15);
if(tf==PERIOD_M30) return(30);
if(tf==PERIOD_H1) return(60);
if(tf==PERIOD_H4) return(240);
if(tf==PERIOD_D1) return(1440);
if(tf==PERIOD_W1) return(10080);
if(tf==PERIOD_MN1) return(43200);
return(Period());
}
//Timeframe To String 
string TFtoString(ENUM_TIMEFRAMES TF)
{
string returnio="";
if(TF==PERIOD_M1) returnio="M1";
if(TF==PERIOD_M5) returnio="M5";
if(TF==PERIOD_M15) returnio="M15";
if(TF==PERIOD_M30) returnio="M30";
if(TF==PERIOD_H1) returnio="H1";
if(TF==PERIOD_H4) returnio="H4";
if(TF==PERIOD_D1) returnio="D1";
if(TF==PERIOD_W1) returnio="W1";
if(TF==PERIOD_MN1) returnio="MN1";
return(returnio);
}

ENUM_TIMEFRAMES StringToTF(string tf)
{
if(tf=="M1"){return(PERIOD_M1);}
if(tf=="M5"){return(PERIOD_M5);}
if(tf=="M15"){return(PERIOD_M15);}
if(tf=="M30"){return(PERIOD_M30);}
if(tf=="H1"){return(PERIOD_H1);}
if(tf=="H4"){return(PERIOD_H4);}
if(tf=="D1"){return(PERIOD_D1);}
if(tf=="W1"){return(PERIOD_W1);}
if(tf=="MN1"){return(PERIOD_MN1);}
return(PERIOD_CURRENT);
}

//For Save Load
bool StringToBoolean(string value){
bool tu=StringToUpper(value);
if(tu)
  {
  if(StringFind(value,"TRUE",0)!=-1){return(true);}
  if(StringFind(value,"FALSE",0)!=-1){return(false);}
  if(StringFind(value,"0",0)!=-1){return(false);}
  if(StringFind(value,"1",0)!=-1){return(true);}
  }
return(false);
}

string BooleanToString(bool v){
if(v){return("TRUE");}
return("FALSE");
}

string TimeToTimestampString(datetime time){
ulong v=(ulong)time;
return(IntegerToString(v));
}

datetime TimeStampStringToTime(string value){
ulong v=(ulong)StringToInteger(value);
return((datetime)v);
}

ENUM_TIMEFRAMES FindHigherTimeframe(ENUM_TIMEFRAMES tf)
{
if(tf==PERIOD_M1){return(PERIOD_M5);}
if(tf==PERIOD_M5){return(PERIOD_M15);}
if(tf==PERIOD_M15){return(PERIOD_M30);}
if(tf==PERIOD_M30){return(PERIOD_H1);}
if(tf==PERIOD_H1){return(PERIOD_H4);}
if(tf==PERIOD_H4){return(PERIOD_D1);}
if(tf==PERIOD_D1){return(PERIOD_W1);}
if(tf==PERIOD_W1){return(PERIOD_MN1);}
if(tf==PERIOD_MN1){return(PERIOD_MN1);}
return(PERIOD_CURRENT);
}

 
struct two_ints
{
int left,right;
two_ints(void){left=0;right=0;}
};
two_ints LongTwoInts(long v)
{
two_ints result;
result.right=(int)(v);
if(v>=0){result.left=(int)(v>>32);}
if(v<0){result.left=(int)((v*(-1))>>32)*(-1);}
return(result);
}
two_ints DatetimeTwoInts(datetime v)
{
two_ints result;
result.right=(int)(v);
result.left=(int)(v>>32);
return(result);
}
long TwoIntsLong(int left,int right)
{
long result=(((long)left)<<32)+((long)right);
return(result);
}
datetime TwoIntsDatetime(int left,int right)
{
datetime result=(datetime)((((ulong)left)<<32)+((ulong)right));
return(result);
}
bool DoesSymbolExist(string the_symbol,bool selected)
{
int sytotal=SymbolsTotal(selected);
for(int s=0;s<sytotal;s++){
if(the_symbol==SymbolName(s,selected)){return(true);}
}
return(false);
}
int TimeDayOfYear(datetime time)
{
MqlDateTime mt;
bool turn=TimeToStruct(time,mt);
return(mt.day_of_year);
}

bool IsTesting(){
return((bool)MQLInfoInteger(MQL_TESTER));
}

bool IsTradeAllowed(){
bool result=(bool)TerminalInfoInteger(TERMINAL_TRADE_ALLOWED);
return(result);
}

bool IsAssetInTradingSession(string asset,ENUM_DAY_OF_WEEK day_of_week){
bool result=false;
datetime session_from=0,session_to=0;
//find total sessions 
int sessions_total=0;
for(int se=0;se<10;se++)
   {
   bool sessexist=SymbolInfoSessionTrade(asset,day_of_week,se,session_from,session_to);
   //if session exists 
     if(sessexist){sessions_total=se+1;}
     else{break;}
   }
//loop into all sessions and if we are not in any of them , return false 
  for(int se=0;se<sessions_total;se++)
  {
  SymbolInfoSessionTrade(asset,day_of_week,se,session_from,session_to);
  //result is "For the day requested ,i.e , today , which server hours can you trade at
  //turn starting time in seconds , i think it is already 
  //so , get the server time 
  datetime servertime=TimeTradeServer();
  //turn
  MqlDateTime mqdt_server;
  bool turn=TimeToStruct(servertime,mqdt_server);
  if(turn){
  //zero minutes , hours and seconds 
    mqdt_server.hour=0;mqdt_server.min=0;mqdt_server.sec=0;
  //back to datetime 
    servertime=StructToTime(mqdt_server);
  //project start server time and end server time by adding the seconds from step one respectively
    session_from=(datetime)((int)(servertime)+(int)(session_from));
    session_to=(datetime)((int)(servertime)+(int)(session_to));
    //Print(asset+" server session from "+TimeToString(session_from,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
    //Print(asset+" server session to   "+TimeToString(session_to,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
    //if we are within that time window then cool
    if(TimeTradeServer()>=session_from&&TimeTradeServer()<=session_to){return(true);}  
  }
  }//loop into sessions ends here
return(false);
}
bool IsConnected(){
bool result=(bool)TerminalInfoInteger(TERMINAL_CONNECTED);
string server_name=AccountInfoString(ACCOUNT_SERVER);
if(StringLen(server_name)<1){result=false;}
return(result);
}
bool IsTradeContextBusy(){
return(IsConnected()&&IsTradeAllowed());
}

bool OrderClose(string symbol,
                ENUM_POSITION_TYPE type,
                ulong ticket,
                double lotsToClose,
                double price,
                ulong slippage,
                ulong magic,
                color clr){
   MqlTradeRequest request;
   MqlTradeResult  result;
   ZeroMemory(request);
bool c_result=false;
/* 
for this to make sense 
in mql5 the Position type holds the direction Buy or sell (position buy or position sell or null)
as this terminal was intended to be for netting accounts ,so you would get the overall direction of the symbol
fast . would !
for hedging accounts ,the positions that are live are accessed with PositionsTotal() loops , and any pending orders 
are accessed with OrdersTotal()
Order type contains all order types 
Also , when we close a position we must send the order type ,it will not accept the position type.
*/
ENUM_ORDER_TYPE otype=ORDER_TYPE_SELL;
if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL){otype=ORDER_TYPE_BUY;}
         
         int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
       //--- setting the operation parameters
         request.action   =TRADE_ACTION_DEAL;        // type of trade operation
         request.position =ticket;          // ticket of the position
         request.symbol   =symbol;          // symbol 
         request.volume   =lotsToClose;                   // volume of the position
         request.deviation=slippage;                        // allowed deviation from the price
         request.price=price;
         request.type =otype;
         request.magic=magic;
         request.type_filling=GetFillingA(symbol);
         
         c_result=OrderSend(request,result);
if(result.retcode!=TRADE_RETCODE_DONE&&result.retcode!=TRADE_RETCODE_PLACED){
c_result=false;}
//Print(result.retcode+" "+result.comment+" "+result.request_id+" Ticket ["+IntegerToString(ticket)+"] type("+EnumToString(otype)+") lots("+DoubleToString(lotsToClose,2)+")");}
return(c_result);
}   

bool OrderDelete(ulong ticket,
                 color clr){
   bool c_result=false;
   MqlTradeRequest request;
   MqlTradeResult  result;
   ZeroMemory(request);
   request.action=TRADE_ACTION_REMOVE;                   // type of trade operation
   request.order =ticket; 
   c_result=OrderSend(request,result);
   if(result.retcode!=TRADE_RETCODE_DONE&&result.retcode!=TRADE_RETCODE_PLACED){
   c_result=false;}
   return(c_result);
} 

string PositionTypeToString(ENUM_POSITION_TYPE type){

return(NULL);
}
double GetSwapsCommisionsFees(ulong position_id,bool swaps,bool commissions,bool fees){
double total=0;
if((swaps||commissions||fees)&&position_id>0){
bool select_hd=HistorySelectByPosition(position_id);
  if(select_hd){
  //deals 
    int deals=HistoryDealsTotal();
    //Print("Deals : "+IntegerToString(deals));
    for(int d=0;d<deals;d++){
    ulong deal_ticket=HistoryDealGetTicket(d);
      if(deal_ticket>0){
      /*
      Print("Deal "+IntegerToString(d)+" "+EnumToString((ENUM_DEAL_TYPE)HistoryDealGetInteger(deal_ticket,DEAL_TYPE)));
      Print("Deal "+IntegerToString(d)+"Profit:"+DoubleToString(HistoryDealGetDouble(deal_ticket,DEAL_PROFIT),2));
      */
      if(swaps){total+=HistoryDealGetDouble(deal_ticket,DEAL_SWAP);}
      if(commissions){total+=HistoryDealGetDouble(deal_ticket,DEAL_COMMISSION);}
      if(fees){total+=HistoryDealGetDouble(deal_ticket,DEAL_FEE);}
      }
    }  
  }
}
return(total);
}

double GetLivePositionSwaps(long ticket){
double total=0;
bool select=PositionSelectByTicket(ticket);
if(select){
total+=PositionGetDouble(POSITION_SWAP);
}
return(total);
}

ENUM_ORDER_TYPE_FILLING GetFillingA( const string Symb, const uint Type = ORDER_FILLING_FOK )
{
  const ENUM_SYMBOL_TRADE_EXECUTION ExeMode = (ENUM_SYMBOL_TRADE_EXECUTION)::SymbolInfoInteger(Symb, SYMBOL_TRADE_EXEMODE);
  const int FillingMode = (int)::SymbolInfoInteger(Symb, SYMBOL_FILLING_MODE);

  return((FillingMode == 0 || (Type >= ORDER_FILLING_RETURN) || ((FillingMode & (Type + 1)) != Type + 1)) ?
         (((ExeMode == SYMBOL_TRADE_EXECUTION_EXCHANGE) || (ExeMode == SYMBOL_TRADE_EXECUTION_INSTANT)) ?
           ORDER_FILLING_RETURN : ((FillingMode == SYMBOL_FILLING_IOC) ? ORDER_FILLING_IOC : ORDER_FILLING_FOK)) :
          (ENUM_ORDER_TYPE_FILLING)Type);
}

string get_program_location_and_name_indicators(){
  string at=__PATH__;
  int leng=StringLen(at);
  string seek_what="\\MQL5\\Indicators\\";
  int sw_leng=StringLen(seek_what);
  int find=StringFind(at,seek_what,0);
  string ne=StringSubstr(at,find+sw_leng,leng-(sw_leng));
  int rep=StringReplace(ne,".mq5",".ex5");
  return(ne);
}
string get_program_location_and_name_experts(){
  string at=__PATH__;
  int leng=StringLen(at);
  string seek_what="\\MQL5\\Experts\\";
  int sw_leng=StringLen(seek_what);
  int find=StringFind(at,seek_what,0);
  string ne=StringSubstr(at,find+sw_leng,leng-(sw_leng));
  int rep=StringReplace(ne,".mq5",".ex5");
  return(ne);
}

double AccountFreeMargin(){
return((double)AccountInfoDouble(ACCOUNT_MARGIN_FREE));
}

string AccountCompany(){
return(AccountInfoString(ACCOUNT_COMPANY));
}

string AccountCurrency(){
return(AccountInfoString(ACCOUNT_CURRENCY));
}

string AccountName(){
return(AccountInfoString(ACCOUNT_NAME));
}

long AccountNumber(){
return(AccountInfoInteger(ACCOUNT_LOGIN));
}

double AccountEquity(){
return((double)AccountInfoDouble(ACCOUNT_EQUITY));
}

int TimeUnixWeek(datetime time){
MqlDateTime mt;
bool turn=TimeToStruct(time,mt);
//go back X days depending on day of week
int backtrack=(mt.day_of_week+1)*86400;
datetime a_saturday=(datetime)(time-backtrack);
//divide by weekly seconds 7*86400 ,mathfloor is the unix week index !
int week_seconds=7*86400;
double week_index=MathFloor(((double)a_saturday)/((double)(week_seconds)));
return(((int)week_index));
}

int TimeUnix4H(datetime time){
int seconds_4h=60*60*4;
double index_4h=MathFloor(((double)time)/((double)(seconds_4h)));
return(((int)index_4h));
}

int TimeUnixMinutesSlot(datetime time,int slot_duration_in_minutes){
int seconds_slot=slot_duration_in_minutes*60;
double index_slot=MathFloor(((double)time)/((double)(seconds_slot)));
return(((int)index_slot));
}
int TimeSecond(datetime time)   {MqlDateTime mt;bool turn=TimeToStruct(time,mt);return(mt.sec);}
int TimeMinute(datetime time)   {MqlDateTime mt;bool turn=TimeToStruct(time,mt);return(mt.min);}
int TimeHour(datetime time)     {MqlDateTime mt;bool turn=TimeToStruct(time,mt);return(mt.hour);}
int TimeDayOfWeek(datetime time){MqlDateTime mt;bool turn=TimeToStruct(time,mt);return(mt.day_of_week);}
int TimeDay(datetime time)      {MqlDateTime mt;bool turn=TimeToStruct(time,mt);return(mt.day);}
int TimeMonth(datetime time)    {MqlDateTime mt;bool turn=TimeToStruct(time,mt);return(mt.mon);}
int TimeYear(datetime time)     {MqlDateTime mt;bool turn=TimeToStruct(time,mt);return(mt.year);}

/*
double AccountFreeMarginCheck(string symbol,ENUM_ORDER_TYPE type,double volume){
//get margin required for one lot 
  double initial_margin=(double)SymbolInfoDouble(symbol,SYMBOL_MARGIN_INITIAL);
  //amount purchased ,pieces to put it broadly 
    double pieces=(double)SymbolInfoDouble(symbol,SYMBOL_TRADE_CONTRACT_SIZE);
    //buy -> pay the Ask price ,sell -> pay the Bid price which is 1/Ask of inverted pair
    double ask=(double)SymbolInfoDouble(symbol,SYMBOL_ASK);
    double one_lot_cost=ask*pieces;
    //but also with leverage the margin needed is less so 
    double leverage=((double)AccountInfoInteger(ACCOUNT_LEVERAGE));
    if(leverage>0){one_lot_cost=one_lot_cost/leverage;}
    //and ,cost of the lot we seek is cost of one lot multiplied by volume
    double our_cost=one_lot_cost*volume;
    
  return(initial_margin*volume);
}
*/

double AccountFreeMarginCheck(string symbol,ENUM_ORDER_TYPE type,double volume){
double mronelot=0.0;
double margin=(double)SymbolInfoDouble(symbol,SYMBOL_MARGIN_INITIAL);
double price=(double)SymbolInfoDouble(symbol,SYMBOL_ASK);
if(type==ORDER_TYPE_SELL){price=(double)SymbolInfoDouble(symbol,SYMBOL_BID);}
bool c=OrderCalcMargin(type,symbol,volume,price,mronelot);
if(c){margin=mronelot;}
return(margin);
}

double OrderProfit(long deal_ticket){
       //select in open
       bool select=PositionSelectByTicket(deal_ticket);
       if(select){return((double)PositionGetDouble(POSITION_PROFIT));}
       if(!select){select=HistorySelectByPosition(deal_ticket);
         if(select)
           {
           int oip=HistoryDealsTotal();
           double sum=0;
           for(int o=0;o<oip;o++)
              {
              ulong historyticket=HistoryDealGetTicket(o);
              sum+=HistoryDealGetDouble(historyticket,DEAL_PROFIT);
              }
              return(sum);
           }
         }
return(0.0);
}
bool IsOrderOpen(long deal_ticket){
return(PositionSelectByTicket(deal_ticket));
}

//user texts per the ease of saving strings (text)
//basics
/*
? :if User text structure has not been defined then define it 
   otherwise the block starting from #ifndef to #endif will be ignored
*/
#ifndef LRUT8
#define LRUT8 8
struct user_text_8
{
ushort text[8];
int    text_size;

user_text_8(void){reset();}
user_text_8(string user_text){reset();from_string(user_text);}

void reset(){text_size=0;ArrayFill(text,0,8,0);}

void from_string(string user_text){
text_size=0;
if(StringLen(user_text)>0){
for(int c=0;c<StringLen(user_text);c++){
if(c>8){break;}
text_size++;
text[text_size-1]=StringGetCharacter(user_text,c);
}}}

bool is_same(user_text_8 &other){
bool same=false;
if(other.text_size==text_size&&text_size!=0){
same=true;
for(int t=0;t<text_size;t++){if(text[t]!=other.text[t]){same=false;break;}}
}
return(same);
}

bool is_same(string user_text){
user_text_8 temp(user_text);
return(is_same(temp));
}

void operator=(string user_text){from_string(user_text);}
bool operator==(string user_text){return(is_same(user_text));}
bool operator!=(string user_text){return(!is_same(user_text));}
bool operator==(user_text_8 &other){return(is_same(other));}
bool operator!=(user_text_8 &other){return(!is_same(other));}
string to_string(){return(ShortArrayToString(text,0,text_size));}
};
#endif 
#ifndef LRUT32
#define LRUT32 32
struct user_text_32
{
ushort text[32];
int    text_size;

user_text_32(void){reset();}
user_text_32(string user_text){reset();from_string(user_text);}

void reset(){text_size=0;ArrayFill(text,0,32,0);}

void from_string(string user_text){
text_size=0;
if(StringLen(user_text)>0){
for(int c=0;c<StringLen(user_text);c++){
if(c>32){break;}
text_size++;
text[text_size-1]=StringGetCharacter(user_text,c);
}}}

bool is_same(user_text_32 &other){
bool same=false;
if(other.text_size==text_size&&text_size!=0){
same=true;
for(int t=0;t<text_size;t++){if(text[t]!=other.text[t]){same=false;break;}}
}
return(same);
}

bool is_same(string user_text){
user_text_32 temp(user_text);
return(is_same(temp));
}

void operator=(string user_text){from_string(user_text);}
bool operator==(string user_text){return(is_same(user_text));}
bool operator!=(string user_text){return(!is_same(user_text));}
bool operator==(user_text_32 &other){return(is_same(other));}
bool operator!=(user_text_32 &other){return(!is_same(other));}
string to_string(){return(ShortArrayToString(text,0,text_size));}
};
#endif 
#ifndef LRUT64
#define LRUT64 64
struct user_text_64
{
ushort text[64];
int    text_size;

user_text_64(void){reset();}
user_text_64(string user_text){reset();from_string(user_text);}

void reset(){text_size=0;ArrayFill(text,0,64,0);}

void from_string(string user_text){
text_size=0;
if(StringLen(user_text)>0){
for(int c=0;c<StringLen(user_text);c++){
if(c>64){break;}
text_size++;
text[text_size-1]=StringGetCharacter(user_text,c);
}}}

bool is_same(user_text_64 &other){
bool same=false;
if(other.text_size==text_size&&text_size!=0){
same=true;
for(int t=0;t<text_size;t++){if(text[t]!=other.text[t]){same=false;break;}}
}
return(same);
}

bool is_same(string user_text){
user_text_64 temp(user_text);
return(is_same(temp));
}

void operator=(string user_text){from_string(user_text);}
bool operator==(string user_text){return(is_same(user_text));}
bool operator!=(string user_text){return(!is_same(user_text));}
bool operator==(user_text_64 &other){return(is_same(other));}
bool operator!=(user_text_64 &other){return(!is_same(other));}
string to_string(){return(ShortArrayToString(text,0,text_size));}
};
#endif 
#ifndef LRUT256
#define LRUT256 256
struct user_text_256
{
ushort text[256];
int    text_size;

user_text_256(void){reset();}
user_text_256(string user_text){reset();from_string(user_text);}

void reset(){text_size=0;ArrayFill(text,0,256,0);}

void from_string(string user_text){
text_size=0;
if(StringLen(user_text)>0){
for(int c=0;c<StringLen(user_text);c++){
if(c>255){break;}
text_size++;
text[text_size-1]=StringGetCharacter(user_text,c);
}}}

bool is_same(user_text_256 &other){
bool same=false;
if(other.text_size==text_size&&text_size!=0){
same=true;
for(int t=0;t<text_size;t++){if(text[t]!=other.text[t]){same=false;break;}}
}
return(same);
}

bool is_same(string user_text){
user_text_256 temp(user_text);
return(is_same(temp));
}

void operator=(string user_text){from_string(user_text);}
bool operator==(string user_text){return(is_same(user_text));}
bool operator!=(string user_text){return(!is_same(user_text));}
bool operator==(user_text_256 &other){return(is_same(other));}
bool operator!=(user_text_256 &other){return(!is_same(other));}
string to_string(){return(ShortArrayToString(text,0,text_size));}
};
#endif
#ifndef LRUT512
#define LRUT512 512
struct user_text_512
{
ushort text[512];
int    text_size;

user_text_512(void){reset();}
user_text_512(string user_text){reset();from_string(user_text);}

void reset(){text_size=0;ArrayFill(text,0,512,0);}

void from_string(string user_text){
text_size=0;
if(StringLen(user_text)>0){
for(int c=0;c<StringLen(user_text);c++){
if(c>511){break;}
text_size++;
text[text_size-1]=StringGetCharacter(user_text,c);
}}}

bool is_same(user_text_512 &other){
bool same=false;
if(other.text_size==text_size&&text_size!=0){
same=true;
for(int t=0;t<text_size;t++){if(text[t]!=other.text[t]){same=false;break;}}
}
return(same);
}

bool is_same(string user_text){
user_text_512 temp(user_text);
return(is_same(temp));
}

void operator=(string user_text){from_string(user_text);}
bool operator==(string user_text){return(is_same(user_text));}
bool operator!=(string user_text){return(!is_same(user_text));}
bool operator==(user_text_512 &other){return(is_same(other));}
bool operator!=(user_text_512 &other){return(!is_same(other));}
string to_string(){return(ShortArrayToString(text,0,text_size));}
}; 
#endif 
//basics